diff --git a/output.py b/output.py
index b6aa277..2787d86 100755
--- a/output.py
+++ b/output.py
@@ -770,45 +1094,145 @@ class YumOutput:
                     else:
                         highlight = False
                     self.simpleEnvraList(ipkg or apkg, ui_overflow=True,
-                                         indent=indent, highlight=highlight,
+                                         indent=pindent, highlight=highlight,
                                          columns=columns)
     
     def displayPkgsInGroups(self, group):
+        """Output information about the packages in a given group
+        
+        :param group: a Group object to output information about
+        """
         print _('\nGroup: %s') % group.ui_name
 
         verb = self.verbose_logger.isEnabledFor(logginglevels.DEBUG_3)
-        if verb:
-            print _(' Group-Id: %s') % to_unicode(group.groupid)
+        if True:
+            print _(' Group-Id: %s') % to_unicode(group.compsid)
+
+        igroup_data = self._groupInstalledData(group)
+        igrp_only   = set()
+        for pkg_name in igroup_data:
+            if igroup_data[pkg_name] == 'installed':
+                igrp_only.add(pkg_name)
+        igrp_only.difference_update(group.packages)
+        all_pkgs = group.packages + list(igrp_only)
+
         pkg_names2pkgs = None
         if verb:
-            pkg_names2pkgs = self._group_names2aipkgs(group.packages)
+            pkg_names2pkgs = self._group_names2aipkgs(all_pkgs)
+        else:
+            pkg_names2pkgs = {}
+            for ipkg in self.rpmdb.searchNames(all_pkgs):
+                if ipkg.name not in pkg_names2pkgs:
+                    pkg_names2pkgs[ipkg.name] = []
+                pkg_names2pkgs[ipkg.name].append(ipkg)
+
         if group.ui_description:
             print _(' Description: %s') % to_unicode(group.ui_description)
         if group.langonly:
             print _(' Language: %s') % group.langonly
 
-        sections = ((_(' Mandatory Packages:'),   group.mandatory_packages),
-                    (_(' Default Packages:'),     group.default_packages),
-                    (_(' Optional Packages:'),    group.optional_packages),
-                    (_(' Conditional Packages:'), group.conditional_packages))
+        sections = (('mandatory', _(' Mandatory Packages:'),
+                     group.mandatory_packages),
+                    ('default',  _(' Default Packages:'),
+                     group.default_packages),
+                    ('optional', _(' Optional Packages:'),
+                     group.optional_packages),
+                    (None, _(' Conditional Packages:'),
+                     group.conditional_packages))
         columns = None
         if verb:
             data = {'envra' : {}, 'rid' : {}}
-            for (section_name, pkg_names) in sections:
-                self._calcDataPkgColumns(data, pkg_names, pkg_names2pkgs)
+            for (section_type, section_name, pkg_names) in sections:
+                self._calcDataPkgColumns(data, pkg_names, pkg_names2pkgs,
+                                         igroup_data=igroup_data)
             data = [data['envra'], data['rid']]
             columns = self.calcColumns(data)
             columns = (-columns[0], -columns[1])
 
-        for (section_name, pkg_names) in sections:
+        for (section_type, section_name, pkg_names) in sections:
+            #  Only display igroup data for things that we'll actually try to
+            # install.
+            if section_type is None:
+                tigroup_data = igroup_data
+            elif section_type in self.conf.group_package_types:
+                tigroup_data = igroup_data
+            else:
+                tigroup_data = None
+
             if len(pkg_names) > 0:
                 print section_name
                 self._displayPkgsFromNames(pkg_names, verb, pkg_names2pkgs,
-                                           columns=columns)
+                                           columns=columns,
+                                           igroup_data=tigroup_data)
+        if igrp_only:
+            print _(' Installed Packages:')
+            self._displayPkgsFromNames(igrp_only, verb, pkg_names2pkgs,
+                                       columns=columns,
+                                       igroup_data=igroup_data)
+
+    def displayGrpsInEnvironments(self, evgroup):
+        """Output information about the groups in a given evgroup
+
+        :param group: an Environment object to output information about
+        """
+        print _('\nEnvironment Group: %s') % evgroup.ui_name
+        print _(' Environment-Id: %s') % to_unicode(evgroup.compsid)
+
+        igroup_data = self._groupInstalledEnvData(evgroup)
+        igrp_only   = set()
+        for grp_name in igroup_data:
+            if igroup_data[grp_name] == 'installed':
+                igrp_only.add(grp_name)
+        igrp_only.difference_update(evgroup.allgroups)
+        all_grps = evgroup.allgroups + list(igrp_only)
+
+        if evgroup.ui_description:
+            print _(' Description: %s') % to_unicode(evgroup.ui_description)
+
+        def _get_igrp_data(item, indent):
+            if not igroup_data:
+                return indent
+
+            assert item in igroup_data
+            if item not in igroup_data or igroup_data[item] == 'available':
+                indent += '+' # Group up/in will install i
+            elif igroup_data[item] == 'installed':
+                indent += '=' # Installed via. group
+            elif igroup_data[item] == 'blacklisted-installed':
+                if False: # Not sure it's worth listing these...
+                    return None # On the other hand, there's mark-packages
+                indent += ' ' # Installed, not via. group
+            else:
+                assert igroup_data[item] == 'blacklisted-available'
+                if False: # Not sure it's worth listing these...
+                    return None
+                indent += '-' # Not installed, and won't be
+            return indent
+
+        sections = ((_(' Mandatory Groups:'), evgroup.groups),
+                    (_(' Optional Groups:'),  evgroup.options))
+
+        for (section_name, grp_names) in sections:
+            if len(grp_names) > 0:
+                print section_name
+                for grp_name in sorted(grp_names):
+                    pindent = _get_igrp_data(grp_name, "   ")
+                    if pindent is None:
+                        continue
+
+                    print "%s%s" % (pindent, grp_name)
+
+        if igrp_only:
+            print _(' Installed Groups:')
+            for grp_name in sorted(igrp_only):
+                print "%s%s", "  ", grp_name
 
     def depListOutput(self, results):
-        """take a list of findDeps results and 'pretty print' the output"""
-        
+        """Format and output a list of findDeps results
+
+        :param results: a list of package dependency information as
+           returned by findDeps
+        """
         verb = self.verbose_logger.isEnabledFor(logginglevels.DEBUG_3)
         for pkg in sorted(results):
             print _("package: %s") % pkg.compactPrint()
@@ -832,7 +1256,18 @@ class YumOutput:
                     print "   provider: %s" % po.compactPrint()
 
     def format_number(self, number, SI=0, space=' '):
-        """Turn numbers into human-readable metric-like numbers"""
+        """Return a human-readable metric-like string representation
+        of a number.
+
+        :param number: the number to be converted to a human-readable form
+        :param SI: If is 0, this function will use the convention
+           that 1 kilobyte = 1024 bytes, otherwise, the convention
+           that 1 kilobyte = 1000 bytes will be used
+        :param space: string that will be placed between the number
+           and the SI prefix
+        :return: a human-readable metric-like string representation of
+           *number*
+        """
         symbols = [ ' ', # (none)
                     'k', # kilo
                     'M', # mega
@@ -870,16 +1305,31 @@ class YumOutput:
 
     @staticmethod
     def format_time(seconds, use_hours=0):
+        """Return a human-readable string representation of a number
+        of seconds.  The string will show seconds, minutes, and
+        optionally hours.
+
+        :param seconds: the number of seconds to convert to a
+           human-readable form
+        :param use_hours: If use_hours is 0, the representation will
+           be in minutes and seconds. Otherwise, it will be in hours,
+           minutes, and seconds
+        :return: a human-readable string representation of *seconds*
+        """
         return urlgrabber.progress.format_time(seconds, use_hours)
 
     def matchcallback(self, po, values, matchfor=None, verbose=None,
                       highlight=None):
-        """ Output search/provides type callback matches. po is the pkg object,
-            values are the things in the po that we've matched.
-            If matchfor is passed, all the strings in that list will be
-            highlighted within the output.
-            verbose overrides logginglevel, if passed. """
-
+        """Output search/provides type callback matches.
+
+        :param po: the package object that matched the search
+        :param values: the information associated with *po* that
+           matched the search
+        :param matchfor: a list of strings to be highlighted in the
+           output
+        :param verbose: whether to output extra verbose information
+        :param highlight: highlighting options for the highlighted matches
+        """
         if self.conf.showdupesfromrepos:
             msg = '%s : ' % po
         else:
@@ -923,7 +1373,15 @@ class YumOutput:
                 item = self._enc(item)
                 can_overflow = False
             else:
-                key = _("Other       : ")
+                provs = []
+                for prov in po.provides:
+                    if prov[0] == item:
+                        provs.append(prov)
+                if provs:
+                    key = _("Provides    : ")
+                    item = yum.misc.prco_tuple_to_string(sorted(provs)[0])
+                else:
+                    key = _("Other       : ")
 
             if matchfor:
                 item = self._sub_highlight(item, highlight, matchfor,
@@ -935,14 +1393,34 @@ class YumOutput:
         print '\n\n'
 
     def matchcallback_verbose(self, po, values, matchfor=None):
+        """Output search/provides type callback matches.  This will
+        output more information than :func:`matchcallback`.
+
+        :param po: the package object that matched the search
+        :param values: the information associated with *po* that
+           matched the search
+        :param matchfor: a list of strings to be highlighted in the
+           output
+        """
         return self.matchcallback(po, values, matchfor, verbose=True)
         
     def reportDownloadSize(self, packages, installonly=False):
-        """Report the total download size for a set of packages"""
+        """Report the total download size for a set of packages
+        
+        :param packages: a list of package objects
+        :param installonly: whether the transaction consists only of installations
+        """
         totsize = 0
         locsize = 0
         insize  = 0
         error = False
+
+        def _call_log(*args):
+            if self.verbose_logger.isEnabledFor(yum.logginglevels.INFO_1):
+                self.verbose_logger.log(logginglevels.INFO_1, *args)
+            elif self.conf.assumeno or not self.conf.assumeyes:
+                self.logger.warn(logginglevels.INFO_1, *args)
+
         for pkg in packages:
             # Just to be on the safe side, if for some reason getting
             # the package size fails, log the error and don't report download
@@ -971,18 +1449,18 @@ class YumOutput:
 
         if (not error):
             if locsize:
-                self.verbose_logger.log(logginglevels.INFO_1, _("Total size: %s"), 
-                                        self.format_number(totsize))
+                _call_log(_("Total size: %s"), self.format_number(totsize))
             if locsize != totsize:
-                self.verbose_logger.log(logginglevels.INFO_1, _("Total download size: %s"), 
-                                        self.format_number(totsize - locsize))
+                _call_log(_("Total download size: %s"),
+                          self.format_number(totsize - locsize))
             if installonly:
-                self.verbose_logger.log(logginglevels.INFO_1,
-                                        _("Installed size: %s"),
-                                        self.format_number(insize))
+                _call_log(_("Installed size: %s"), self.format_number(insize))
 
     def reportRemoveSize(self, packages):
-        """Report the total size of packages being removed. """
+        """Report the total size of packages being removed.
+
+        :param packages: a list of package objects
+        """
         totsize = 0
         error = False
         for pkg in packages:
@@ -997,13 +1475,19 @@ class YumOutput:
                 self.logger.error(_('There was an error calculating installed size'))
                 break
         if (not error):
-            self.verbose_logger.log(logginglevels.INFO_1,
-                                    _("Installed size: %s"),
-                                    self.format_number(totsize))
+            if self.verbose_logger.isEnabledFor(yum.logginglevels.INFO_1):
+                self.verbose_logger.log(logginglevels.INFO_1,
+                                        _("Installed size: %s"),
+                                        self.format_number(totsize))
+            elif self.conf.assumeno or not self.conf.assumeyes:
+                self.logger.warn(logginglevels.INFO_1,
+                                 _("Installed size: %s"),
+                                 self.format_number(totsize))
             
     def listTransaction(self):
-        """returns a string rep of the  transaction in an easy-to-read way."""
-        
+        """Return a string representation of the transaction in an
+        easy-to-read format.
+        """
         self.tsInfo.makelists(True, True)
         pkglist_lines = []
         data  = {'n' : {}, 'v' : {}, 'r' : {}}
@@ -1032,11 +1516,43 @@ class YumOutput:
             for (d, v) in (("n",len(n)), ("v",len(evr)), ("r",len(repoid))):
                 data[d].setdefault(v, 0)
                 data[d][v] += 1
-            if a_wid < len(a): # max() is only in 2.5.z
-                a_wid = len(a)
+            a_wid = max(a_wid, len(a))
             return a_wid
 
-        for (action, pkglist) in [(_('Installing'), self.tsInfo.installed),
+        ninstalled = self.tsInfo.installed
+        ginstalled = {}
+        if self.conf.group_command == 'objects' and ninstalled:
+            # Show new pkgs. that are installed via. a group.
+            ninstalled = []
+            for txmbr in self.tsInfo.installed:
+                if hasattr(txmbr, '_igroup_member'):
+                    key = ('i', txmbr._igroup_member)
+                    if key not in ginstalled:
+                        ginstalled[key] = []
+                    ginstalled[key].append(txmbr)
+                elif hasattr(txmbr, '_ugroup_member'):
+                    key = ('u', txmbr._ugroup_member)
+                    if key not in ginstalled:
+                        ginstalled[key] = []
+                    ginstalled[key].append(txmbr)
+                else:
+                    ninstalled.append(txmbr)
+
+        for (T, grp) in sorted(ginstalled, key=lambda x: x[1].ui_name):
+            if T == 'u':
+                msg = _('Installing for group upgrade "%s"')
+            else:
+                msg = _('Installing for group install "%s"')
+            action = msg % grp.ui_name
+            pkglist = ginstalled[(T, grp)]
+
+            lines = []
+            for txmbr in pkglist:
+                a_wid = _add_line(lines, data, a_wid, txmbr.po, txmbr.obsoletes)
+
+            pkglist_lines.append((action, lines))
+
+        for (action, pkglist) in [(_('Installing'), ninstalled),
                             (_('Updating'), self.tsInfo.updated),
                             (_('Removing'), self.tsInfo.removed),
                             (_('Reinstalling'), self.tsInfo.reinstalled),
@@ -1102,19 +1618,72 @@ class YumOutput:
 Transaction Summary
 %s
 """) % ('=' * self.term.columns))
-        for action, count in (
-            (_('Install'), len(self.tsInfo.installed) + len(self.tsInfo.depinstalled)),
-            (_('Upgrade'), len(self.tsInfo.updated) + len(self.tsInfo.depupdated)),
-            (_('Remove'), len(self.tsInfo.removed) + len(self.tsInfo.depremoved)),
-            (_('Reinstall'), len(self.tsInfo.reinstalled)),
-            (_('Downgrade'), len(self.tsInfo.downgraded)),
-        ):
-            if count: out.append('%-9s %5d %s\n' % (
-                action, count, P_('Package', 'Packages', count),
-            ))
+        summary_data =  (
+            (_('Install'), len(self.tsInfo.installed),
+             len(self.tsInfo.depinstalled)),
+            (_('Upgrade'), len(self.tsInfo.updated),
+             len(self.tsInfo.depupdated)),
+            (_('Remove'), len(self.tsInfo.removed),
+             len(self.tsInfo.depremoved)),
+            (_('Reinstall'), len(self.tsInfo.reinstalled), 0),
+            (_('Downgrade'), len(self.tsInfo.downgraded), 0),
+            (_('Skipped (dependency problems)'), len(self.skipped_packages), 0),
+            (_('Not installed'), len(self._not_found_i.values()), 0),
+            (_('Not available'), len(self._not_found_a.values()), 0),
+        )
+        max_msg_action   = 0
+        max_msg_count    = 0
+        max_msg_pkgs     = 0
+        max_msg_depcount = 0
+        for action, count, depcount in summary_data:
+            if not count and not depcount:
+                continue
+
+            msg_pkgs = P_('Package', 'Packages', count)
+            len_msg_action   = utf8_width(action)
+            len_msg_count    = utf8_width(str(count))
+            len_msg_pkgs     = utf8_width(msg_pkgs)
+
+            if depcount:
+                len_msg_depcount = utf8_width(str(depcount))
+            else:
+                len_msg_depcount = 0
+
+            max_msg_action   = max(len_msg_action,   max_msg_action)
+            max_msg_count    = max(len_msg_count,    max_msg_count)
+            max_msg_pkgs     = max(len_msg_pkgs,     max_msg_pkgs)
+            max_msg_depcount = max(len_msg_depcount, max_msg_depcount)
+
+        for action, count, depcount in summary_data:
+            msg_pkgs = P_('Package', 'Packages', count)
+            if depcount:
+                msg_deppkgs = P_('Dependent package', 'Dependent packages',
+                                 depcount)
+                if count:
+                    msg = '%s  %*d %s (+%*d %s)\n'
+                    out.append(msg % (utf8_width_fill(action, max_msg_action),
+                                      max_msg_count, count,
+                                      utf8_width_fill(msg_pkgs, max_msg_pkgs),
+                                      max_msg_depcount, depcount, msg_deppkgs))
+                else:
+                    msg = '%s  %*s %s ( %*d %s)\n'
+                    out.append(msg % (utf8_width_fill(action, max_msg_action),
+                                      max_msg_count, '',
+                                      utf8_width_fill('', max_msg_pkgs),
+                                      max_msg_depcount, depcount, msg_deppkgs))
+            elif count:
+                msg = '%s  %*d %s\n'
+                out.append(msg % (utf8_width_fill(action, max_msg_action),
+                                  max_msg_count, count, msg_pkgs))
         return ''.join(out)
         
     def postTransactionOutput(self):
+        """Returns a human-readable summary of the results of the
+        transaction.
+        
+        :return: a string containing a human-readable summary of the
+           results of the transaction
+        """
         out = ''
         
         self.tsInfo.makelists()
@@ -1179,17 +1748,19 @@ Transaction Summary
         return out
 
     def setupProgressCallbacks(self):
-        """sets up the progress callbacks and various 
-           output bars based on debug level"""
-
+        """Set up the progress callbacks and various 
+           output bars based on debug level.
+        """
         # if we're below 2 on the debug level we don't need to be outputting
         # progress bars - this is hacky - I'm open to other options
         # One of these is a download
         if self.conf.debuglevel < 2 or not sys.stdout.isatty():
             progressbar = None
+            multi_progressbar = None
             callback = None
         else:
             progressbar = YumTextMeter(fo=sys.stdout)
+            multi_progressbar = YumTextMultiFileMeter(fo=sys.stdout)
             callback = CacheProgressCallback()
 
         # setup our failure report for failover
@@ -1200,13 +1771,14 @@ Transaction Summary
         interrupt_callback = self.interrupt_callback
         if hasattr(self, 'prerepoconf'):
             self.prerepoconf.progressbar = progressbar
+            self.prerepoconf.multi_progressbar = multi_progressbar
             self.prerepoconf.callback = callback
             self.prerepoconf.failure_callback = failure_callback
             self.prerepoconf.interrupt_callback = interrupt_callback
         else:
             #  Just in case some API user decides to do self.repos before
             # calling us.
-            self.repos.setProgressBar(progressbar)
+            self.repos.setProgressBar(progressbar, multi_progressbar)
             self.repos.callback = callback
             self.repos.setFailureCallback(failure_callback)
             self.repos.setInterruptCallback(interrupt_callback)
@@ -1216,10 +1788,12 @@ Transaction Summary
         self.dsCallback = dscb
     
     def setupProgessCallbacks(self):
-        # api purposes only to protect the typo
+        """This function is for API purposes only to protect the typo."""
         self.setupProgressCallbacks()
     
     def setupKeyImportCallbacks(self):
+        """Set up callbacks to import and confirm gpg public keys."""
+
         confirm_func = self._cli_confirm_gpg_key_import
         gpg_import_func = self.getKeyForRepo
         gpgca_import_func = self.getCAKeyForRepo
@@ -1233,14 +1807,12 @@ Transaction Summary
             self.repos.gpgca_import_func = gpgca_import_func
 
     def interrupt_callback(self, cbobj):
-        '''Handle CTRL-C's during downloads
-
-        If a CTRL-C occurs a URLGrabError will be raised to push the download
-        onto the next mirror.  
-        
-        If two CTRL-C's occur in quick succession then yum will exit.
+        '''Handle CTRL-C's during downloads.  If a CTRL-C occurs a
+        URLGrabError will be raised to push the download onto the next
+        mirror.  If two CTRL-C's occur in quick succession then yum
+        will exit.
 
-        @param cbobj: urlgrabber callback obj
+        :param cbobj: :class:`urlgrabber.grabber.CallbackObject`
         '''
         delta_exit_chk = 2.0      # Delta between C-c's so we treat as exit
         delta_exit_str = _("two") # Human readable version of above
@@ -1253,7 +1825,7 @@ Transaction Summary
             # For translators: This is output like:
 #  Current download cancelled, interrupt (ctrl-c) again within two seconds
 # to exit.
-            # Where "interupt (ctrl-c) again" and "two" are highlighted.
+            # Where "interrupt (ctrl-c) again" and "two" are highlighted.
             msg = _("""
  Current download cancelled, %sinterrupt (ctrl-c) again%s within %s%s%s seconds
 to exit.
@@ -1269,6 +1841,14 @@ to exit.
 
     def download_callback_total_cb(self, remote_pkgs, remote_size,
                                    download_start_timestamp):
+        """Outputs summary information about the download process.
+
+        :param remote_pkgs: a list of package objects that were downloaded
+        :param remote_size: the total amount of information that was
+           downloaded, in bytes
+        :param download_start_timestamp: the time when the download
+           process started, in seconds since the epoch
+        """
         if len(remote_pkgs) <= 1:
             return
         if not hasattr(urlgrabber.progress, 'TerminalLine'):
@@ -1280,7 +1860,7 @@ to exit.
         if dl_time <= 0: # This stops divide by zero, among other problems
             dl_time = 0.01
         ui_size = tl.add(' | %5sB' % self.format_number(remote_size))
-        ui_time = tl.add(' %9s' % self.format_time(dl_time))
+        ui_time = tl.add('  %s' % self.format_time(dl_time, tl._llen > 80))
         ui_end  = tl.add(' ' * 5)
         ui_bs   = tl.add(' %5sB/s' % self.format_number(remote_size / dl_time))
         msg = "%s%s%s%s%s" % (utf8_width_fill(_("Total"), tl.rest(), tl.rest()),
@@ -1434,10 +2014,21 @@ to exit.
         return tids, printall
 
     def historyListCmd(self, extcmds):
-        """ Shows the user a list of data about the history. """
+        """Output a list of information about the history of yum
+        transactions.
 
+        :param extcmds: list of extra command line arguments
+        :return: (exit_code, [errors])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+        """
         tids, printall = self._history_list_transactions(extcmds)
         if tids is None:
+            if not extcmds: # This is not a real error...
+                return 0, ['No accessible history to list']
             return 1, ['Failed history list']
 
         limit = 20
@@ -1564,6 +2155,16 @@ to exit.
         return old[0]
 
     def historyInfoCmd(self, extcmds):
+        """Output information about a transaction in history
+
+        :param extcmds: list of extra command line arguments
+        :return: (exit_code, [errors])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+        """
         def str2int(x):
             try:
                 return int(x)
@@ -1656,6 +2257,9 @@ to exit.
     def _hpkg2from_repo(self, hpkg):
         """ Given a pkg, find the ipkg.ui_from_repo ... if none, then
             get an apkg. ... and put a ? in there. """
+        if 'from_repo' in hpkg.yumdb_info:
+            return hpkg.ui_from_repo
+
         ipkgs = self.rpmdb.searchPkgTuple(hpkg.pkgtup)
         if not ipkgs:
             apkgs = self.pkgSack.searchPkgTuple(hpkg.pkgtup)
@@ -1672,13 +2276,12 @@ to exit.
                                  'o' : _('Updated'), 'n' : _('Downgraded')}
         _pkg_states_available = {'i' : _('Installed'), 'e' : _('Not installed'),
                                  'o' : _('Older'), 'n' : _('Newer')}
-        # max() only in 2.5.z
-        maxlen = sorted([len(x) for x in (_pkg_states_installed.values() +
-                                          _pkg_states_available.values())])[-1]
+        maxlen = max([len(x) for x in (_pkg_states_installed.values() +
+                                       _pkg_states_available.values())])
         _pkg_states_installed['maxlen'] = maxlen
         _pkg_states_available['maxlen'] = maxlen
         def _simple_pkg(pkg, prefix_len, was_installed=False, highlight=False,
-                        pkg_max_len=0):
+                        pkg_max_len=0, show_repo=True):
             prefix = " " * prefix_len
             if was_installed:
                 _pkg_states = _pkg_states_installed
@@ -1702,9 +2305,11 @@ to exit.
             else:
                 (hibeg, hiend) = self._highlight('normal')
             state = utf8_width_fill(state, _pkg_states['maxlen'])
+            ui_repo = ''
+            if show_repo:
+                ui_repo = self._hpkg2from_repo(hpkg)
             print "%s%s%s%s %-*s %s" % (prefix, hibeg, state, hiend,
-                                        pkg_max_len, hpkg,
-                                        self._hpkg2from_repo(hpkg))
+                                        pkg_max_len, hpkg, ui_repo)
 
         if type(old.tid) == type([]):
             print _("Transaction ID :"), "%u..%u" % (old.tid[0], old.tid[-1])
@@ -1778,8 +2383,8 @@ to exit.
             default_addons = set(['config-main', 'config-repos', 'saved_tx'])
             non_default = set(addon_info).difference(default_addons)
             if len(non_default) > 0:
-                    print _("Additional non-default information stored: %d" 
-                                % len(non_default))
+                print _("Additional non-default information stored: %d" 
+                            % len(non_default))
 
         if old.trans_with:
             # This is _possible_, but not common
@@ -1794,7 +2399,9 @@ to exit.
             print _("Packages Skipped:")
             pkg_max_len = max((len(str(hpkg)) for hpkg in old.trans_skip))
         for hpkg in old.trans_skip:
-            _simple_pkg(hpkg, 4, pkg_max_len=pkg_max_len)
+            #  Don't show the repo. here because we can't store it as they were,
+            # by definition, not installed.
+            _simple_pkg(hpkg, 4, pkg_max_len=pkg_max_len, show_repo=False)
 
         if old.rpmdb_problems:
             print _("Rpmdb Problems:")
@@ -1833,6 +2440,13 @@ to exit.
                               'Updated'      : _('Updated'),
                               }
     def historyInfoCmdPkgsAltered(self, old, pats=[]):
+        """Print information about how packages are altered in a transaction.
+
+        :param old: the :class:`history.YumHistoryTransaction` to
+           print information about
+        :param pats: a list of patterns.  Packages that match a patten
+           in *pats* will be highlighted in the output
+        """
         last = None
         #  Note that these don't use _simple_pkg() because we are showing what
         # happened to them in the transaction ... not the difference between the
@@ -1886,6 +2500,10 @@ to exit.
                                         self._hpkg2from_repo(hpkg))
 
     def historySummaryCmd(self, extcmds):
+        """Print a summary of transactions in history.
+
+        :param extcmds: list of extra command line arguments
+        """
         tids, printall = self._history_list_transactions(extcmds)
         if tids is None:
             return 1, ['Failed history info']
@@ -1946,6 +2564,10 @@ to exit.
                              utf8_width_fill(uiacts, 16, 16), count)
 
     def historyAddonInfoCmd(self, extcmds):
+        """Print addon information about transaction in history.
+
+        :param extcmds: list of extra command line arguments
+        """
         tid = None
         if len(extcmds) > 1:
             tid = extcmds[1]
